import java.io.*;
import java.util.*;
import java.awt.*;
import javax.swing.*;

public class Sidepane extends JPanel implements Observer
{
  private Model model;
  private Colours colours;
  private JPanel thiccness;

  // Bob the Builder this shit
  public Sidepane(Model model, Handler handler)
  {
    // Hook up this observer so that it will be notified when the model
    // changes.
    this.model = model;
    this.setPreferredSize(new Dimension(280, 720));
    colours = new Colours();
    this.add(colours);
    model.addObserver(this);
  }

  /**
  * Update with data from the model.
  */
  public void update(Object observable)
  {
    this.setBackground(model.sideColour);
    revalidate();
    repaint();
  }
}

class Colours extends JPanel
{
  private JButton red;
  private JButton green;
  private JButton blue;
  private JButton yellow;
  private JButton purple;
  private JButton orange;
  private JButton cyan;
  private JButton custom;
  private ArrayList<colourButton> colours;

  public Colours()
  {
    this.setLayout(new GridLayout(0, 2));
    this.setPreferredSize(new Dimension(280, 600));
    colours.add(new colourButton(Color.red));
    colours.add(new colourButton(Color.green));
    colours.add(new colourButton(Color.blue));
    colours.add(new colourButton(Color.yellow));
    colours.add(new colourButton(Color.magenta));
    colours.add(new colourButton(Color.orange));
    colours.add(new colourButton(Color.cyan));
    colours.add(new colourButton(Color.gray));
    
    for(colourButton b: colours)
    {
      this.add(b);
    }
  }
}

class colourButton extends JButton
{
  public colourButton(Color c)
  {
    this.setPreferredSize(new Dimension(140, 150));
    this.setBackground(c);
    this.setOpaque(true);
  }
  
  public String toString()
  {
    return this.getBackground().toString();
  }
}